# comparing the different paths we realise there are invariable parts and variable ones
# don't execute the 4 next lines it just to highlight what's common and different between the different paths.
s1path = "~/Nos_Documents/Seb_work/Enseignements/Rcourse/data/FromStudents/M/samples/S1/resultats/S1exp1.csv"
s1path = "~/Nos_Documents/Seb_work/Enseignements/Rcourse/data/FromStudents/M/samples/S2/resultats/S2exp1.csv"
s1path = "~/Nos_Documents/Seb_work/Enseignements/Rcourse/data/FromStudents/M/samples/S3/resultats/S3exp1.csv"
s4path = "~/Nos_Documents/Seb_work/Enseignements/Rcourse/data/FromStudents/M/samples/S4/resultats/S4exp1.csv"

# -> only the sample id (S1, S2, S3, S4) changes between lines
# "~/Nos_Documents/Seb_work/Enseignements/Rcourse/data/FromStudents/M/samples/" sampleID "/resultats/" sampleID, "exp1.csv"

# it is then easy to use de paste function to get a specific path corresponding to a given sample  
# create a vector containing the different sample id (different options)
# option 1
# my_samples <- c("S1", "S2", "S3", "S4") # too long if there are plenty of samples

# option 2
my_samples <- paste0("S", 1:4) # better, specially if there are plenty of samples (although they have to be named exactly in the same way)

# option 3
# automatise previous line : if we list the folders stored at 
# "~/Nos_Documents/Seb_work/Enseignements/Rcourse/data/FromStudents/M/samples/"
# we can automatically got the vector using the list.files() function
my_samples <- list.files(path = "~/Nos_Documents/Seb_work/Enseignements/Rcourse/data/FromStudents/M/samples/")

# all three options will, in that case, give the same results

# -----

# we are now ready to make a loop to change directory and read the correct ".csv" files stored in folder "resultats" for each sample

indexloop <- 0 # optional : will indicate the loop iteration number
for(sId in my_samples){ #sId = at each loop iteration this variable will take a new value from "my_samples" vector
  # Loop iteration counter incrementation
  indexloop <- indexloop + 1 
  
  # print out the iteration number
  cat("loop iteration numero : ", indexloop, "\n") 
  
  # print value affected to varaible sId in the current iteration
  print(sId) 
  
  # we use paste to 'create' the path pointing to where the .csv files are stored
  # the path is stored in a variable names "wd"
  wd <- paste0("~/Nos_Documents/Seb_work/Enseignements/Rcourse/data/FromStudents/M/samples/",sId,"/resultats/") 
  
  # print out the 'created' path
  print(wd)
  
  # change the working directory to where the wanted .csv files is stored
  setwd(wd)
  # the function list.files() will produce a character vector of the names of files in the named directory.
  files_in_wd <- list.files()
  
  # print out the different files in the "wd" directory
  print(files_in_wd)
  
  # In some cases, the directory contains unwanted files.
  # we want files like XXesp1.csv XX being the sample id.
  # again several option to fetch the right file
  # manually with paste0()
  file2read <- paste0(sId,"exp1.csv")
  # # with a grep
  # file2read <- grep("exp1.csv", file2read, value = TRUE)
  
  # make a name for the attributed variable : "varName" will be the name given to the attributed variable
  varName <- gsub(".csv","", file2read) # here, the function gsub(), will replace any ".csv" in file2read by an empty string (for instance : "S1exp1.csv" will become "S1exp1")
  
  # we can now assign to the varName variable the table we are going to import using the read.csv() function
  # the parameter 'skip' in the read.csv() funciton allows to read the table skipping the first here 84 lines (i.e starting at the 85th line)
  # the assign function assigns a value to a name in an environment
  assign(file2read, read.csv(file2read, stringsAsFactors = FALSE, skip = 84))
  
  # # If correction needs to be made on the table, we can do it while importing the table (or later...)
  # # the table is then stored in a temporary variable 'tab_tmp'...
  # tab_tmp <- read.csv(file = file2read, stringsAsFactors = FALSE, skip = 84)
  # # ... and tab_tmp can be modified before the assign()
  # tab_tmp <- tab_tmp[tab_tmp$BLOCK.NUMBER %in% 1:10,] #modification of the table
  # assign(varName, tab_tmp) # assigning the modified table to the choosen variable name
  cat("------------\n\n") # cosmetic only
}

# example of ways to remove unwanted lines in the importated table (if not done in the loop)
table(S1exp1$BLOCK.NUMBER)
S1exp1_corr <- S1exp1[which(S1exp1$BLOCK.NUMBER %in% 1:10),]
S1exp1_corr <- S1exp1.csv[S1exp1.csv$BLOCK.NUMBER != "BLOCK NUMBER" & S1exp1.csv$BLOCK.NUMBER != "FILE END",]
# there problably are other ways...
